﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	'Menu-------------------------------------------------------------------------------
	'5 bits - meaning
	' 1.	1 visible          0 invisible
	' 2.	1 enabled          0 disabled
	' 3.	1 checked          0 not checked
	' 4.	1 have line after  0 no line after
	' 5.	1 have next menu   0 no next menu
	Private Menu1() As String '10-14
	Menu1 = Array As String("11000Menu 10", "11011Menu 11", "10000Menu 12", "10010Menu____ 13", "11000Menu 14")
	'1. submenu
	Private Menu12() As String '20-22
	Menu12 = Array As String("10010Menu 120", "11100Menu 121", "11001Menu 122")
	'2. submenu
	Private Menu123() As String '25-27
	Menu123 = Array As String("11011Menu 1230", "11100Menu 1231", "10100Menu 1232")
	'3. submenu
	Private Menu1231() As String '30-36
	Menu1231 = Array As String("11010Menu 12310", "11100Menu 12311", "11000Menu 12312", "10110Menu 12313", "11100Menu 12314", "10000Menu 12315", "11100Menu 12316")
		
	Private Menu2() As String '100-105
	Menu2 = Array As String("11110Menu 20", "11000Menu 21", "11010Menu 22", "11011Menu 23", "11000Menu 24...", "11001Menu 25")
	'2. submenu
	Private Menu21() As String '110-112
	Menu21 = Array As String("11100Menu 210", "10010Menu 211", "11000Menu 212")
	'2. submenu
	Private Menu22() As String '115-116
	Menu22 = Array As String("11110Menu 220", "10010Menu 221")
	'End Menu------------------------------------------------------------------------------------
	'DSmenu
	Dim LevelDSMenu = 4 As Int
	Private DSmenu1 As CustomListMenuView
	Private DSmenu2 As CustomListMenuView
	Private DSmenu3 As CustomListMenuView
	Private DSmenu4 As CustomListMenuView
'	Private DSmenu5 As CustomListMenuView
'	Private DSmenu6 As CustomListMenuView
	Private pnlDSmenu(LevelDSMenu) As Panel
	Private pnlShadow(LevelDSMenu) As Panel
	Private pnlDSmenuInvisible As Panel
	Private PanelHe As Int
	Private DSmenu() As CustomListMenuView
	DSmenu = Array  As CustomListMenuView(DSmenu1, DSmenu2, DSmenu3, DSmenu4)
	Private ColWidthDSmenu(LevelDSMenu) As Int
	Private RowHeightDSmenu As Int
	Private NumberOfRowsDSmenu As Int						: NumberOfRowsDSmenu=0
	Private AlignmentDSmenu(3) As Int
	AlignmentDSmenu(0) = Gravity.CENTER
	AlignmentDSmenu(1) = Gravity.LEFT
	AlignmentDSmenu(2) = Gravity.CENTER
	Private WidthMax As Int
	Private WidthMenu As Int
	Private lblInvisible As Label
	Private lv As LayoutValues
	Private DeviceSize As Double
	Private mPhone As Boolean
	Private Tablet As Boolean
	Public TextSize As Float
	' For test---------------------
	Private Panel1 As Panel
	Private m1 As Button
	Private m2 As Button
	Private Label3 As Label
	Private Label6 As Label
	Private Buttons(5) As Button
	'-------------------------End for test
End Sub

Public Sub Initialize

End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("1") 'For test
	CheckDeviceType
	MakeDSmenu
	'for test------------
	Panel1.Width=Root.Width
	Panel1.Height=Root.Height
	Label6.Top = 55%y
	Dim i As Int
	For i = 0 To 4
		Buttons(i).Initialize("Buttons")
		Root.AddView(Buttons(i), i*20%x, 70%y, 20%x, 8%y)
		Buttons(i).Tag = i + 1
		Buttons(i).Text = "Bt " & (i + 1)
		Buttons(i).TextSize = TextSize
	Next
	'-----------------------
End Sub

Sub B4XPage_CloseRequest As ResumableSub
	If Main.KeyCode1 = KeyCodes.KEYCODE_BACK Then
		Dim i As Int
		Dim j As Boolean
		If pnlDSmenuInvisible.IsInitialized And pnlDSmenuInvisible.Visible Then
			For i = 0 To 2
				If DSmenu(i).IsInitialized Then
					DSmenu(i).Clear
					pnlShadow(i).Visible=False
					j = True
				End If
			Next
			pnlDSmenuInvisible.Visible = False
			If j Then
				Return False
			End If
		End If
	End If
	CloseActivities
	Return True
End Sub

Sub MakeDSmenu
	Dim i As Int
	If mPhone Or (Tablet And Root.Width < Root.Height) Then
		WidthMenu = 3%y
		RowHeightDSmenu = 5%y 'change for bigger od smaller menu fontsize
		lblInvisible.Height = RowHeightDSmenu
	Else
		WidthMenu = 5%y
		RowHeightDSmenu = 7%y 'change for bigger od smaller menu fontsize
		lblInvisible.Height = RowHeightDSmenu
	End If
	lblInvisible.Text="123"
	SetLabelTextSize(lblInvisible, lblInvisible.Text)
	TextSize = lblInvisible.TextSize*.8
	pnlDSmenuInvisible.Initialize("pnlDSmenuInvisible")
	Root.AddView(pnlDSmenuInvisible, 0, 0, Root.Width, Root.Height)
	pnlDSmenuInvisible.Color = Colors.Transparent
	pnlDSmenuInvisible.Elevation = 30dip
	pnlDSmenuInvisible.Visible = False
	For i = 0 To LevelDSMenu - 1
		pnlDSmenu(i).Initialize("")
		pnlShadow(i).Initialize("")
		pnlDSmenuInvisible.AddView(pnlShadow(i), 1%x, 1%y, 1%x, 1%y)
		pnlShadow(i).AddView(pnlDSmenu(i), 0, 0, 1%y, 1%y)
		pnlShadow(i).SetBackgroundImage(LoadBitmap(File.DirAssets,"trans.png"))
	Next
End Sub

Sub CheckDeviceType
	lv = GetDeviceLayoutValues
	DeviceSize = lv.ApproximateScreenSize
	If DeviceSize < 6 Then
		mPhone  =True
	End If
	Dim p As Phone
	If mPhone Then
		p.SetScreenOrientation(1)
	Else
		Tablet = True
		If Root.Width < Root.Height Then
			mPhone = True
			p.SetScreenOrientation(1)
		Else
			mPhone = False
			p.SetScreenOrientation(0)
		End If
	End If
End Sub

Sub SpecifyGrid(i As Int) As Int
'	Private Menu1() As String '10-14
'	'1. submenu
'	Private Menu12() As String '20-22
'	'2. submenu
'	Private Menu123() As String '25-27
'	'3. submenu
'	Private Menu1231() As String '30-36

'	Private Menu2() As String '100-105
'	'2. submenu
'	Private Menu21() As String '110-112
'	'2. submenu
'	Private Menu22() As String '115-116
	If  (i >= 10 And i <= 14) Or (i >= 100 And i <= 105) Then
		Return 0
	Else If (i >= 20 And i <= 22) Or (i >= 110 And i <= 112)  Or (i >= 115 And i <= 116) Then
		Return 1
	Else if (i >= 25 And i <= 27) Then
		Return 2
	Else if i >= 30 And i <= 36 Then
		Return 3
	Else
		Log("Error menu")
		Return 4
	End If
End Sub

Sub ShowDSMenu(From1 As Int,To1 As Int,MenuS() As String,v As View,rbrMenu As Int,TopPlus As Int,LeftPlus As Int)
	Dim i, j As Int
	Dim e As Boolean
	Dim d As Float
	If rbrMenu < 3 Then
		For i = rbrMenu To 3
			If DSmenu(i).IsInitialized Then
				DSmenu(i).Clear
				pnlShadow(i).Visible = False
			End If
		Next
	End If
	Dim leftTop(2) As Int
	If rbrMenu = 0 Then
		Dim JO As JavaObject = v
		JO.RunMethod("getLocationOnScreen", Array As Object(leftTop))
	End If
	Dim viewLeft As Int = leftTop(0)
	Dim viewTop As Int = leftTop(1)-25dip
	SpecifyWidth(From1, To1, MenuS)
	pnlDSmenu(rbrMenu).Width=WidthMax + 2 * WidthMenu
	PanelHe = 0
	j = 0
	For i = From1 To To1
		If MenuS(j).SubString2(0,1) = "1" And MenuS(j).Length > 5 Then
			If MenuS(j).SubString2(3,4) = "0" Then
				d = 0
			Else
				d = 2dip
			End If
			If PanelHe < Root.Height/1.15 Then PanelHe = PanelHe + RowHeightDSmenu + d
		End If
		j = j + 1
	Next
	pnlDSmenu(rbrMenu).Height=PanelHe
	pnlShadow(rbrMenu).Width=pnlDSmenu(rbrMenu).Width * 1.04
	pnlShadow(rbrMenu).Height=pnlDSmenu(rbrMenu).Height * 1.03
	
	'---where is show----
	Select rbrMenu
		Case 0
			If (viewTop + v.Height) < Root.Height / 2 Then 'gore
				pnlShadow(rbrMenu).Left = viewLeft + LeftPlus * WidthMenu
				pnlShadow(rbrMenu).Top = viewTop + v.Height + 1dip + TopPlus * RowHeightDSmenu
			Else 'down
				If (viewLeft + v.Width) < Root.Width / 2 Then
					pnlShadow(rbrMenu).Left = viewLeft + v.Width + 1dip + LeftPlus * WidthMenu
				Else
					pnlShadow(rbrMenu).Left = viewLeft - pnlShadow(rbrMenu).Width - 1dip + LeftPlus * WidthMenu
				End If
				pnlShadow(rbrMenu).Top = viewTop + v.Height / 2 - pnlShadow(rbrMenu).Height + TopPlus * RowHeightDSmenu
			End If
		Case Else
			If (pnlShadow(rbrMenu - 1).Left + pnlShadow(rbrMenu - 1).Width) = Root.Width Then
				pnlShadow(rbrMenu).Left = pnlShadow(rbrMenu - 1).Left - pnlDSmenu(rbrMenu).Width + 1dip + LeftPlus * WidthMenu
			Else
				pnlShadow(rbrMenu).Left = pnlShadow(rbrMenu - 1).Left + pnlDSmenu(rbrMenu - 1).Width + 1dip + LeftPlus * WidthMenu
			End If
			pnlShadow(rbrMenu).Top = pnlShadow(rbrMenu - 1).Top + TopPlus * RowHeightDSmenu
	End Select
	If pnlShadow(rbrMenu).Left < 0 Then pnlShadow(rbrMenu).Left = 0
	If (pnlShadow(rbrMenu).Left + pnlShadow(rbrMenu).Width) > Root.Width Then
		pnlShadow(rbrMenu).Left = Root.Width - pnlShadow(rbrMenu).Width
	End If
	If pnlShadow(rbrMenu).Left < 0 Then pnlShadow(rbrMenu).Left = 0
	If (pnlShadow(rbrMenu).Top + pnlShadow(rbrMenu).Height) > Root.Height Then
		pnlShadow(rbrMenu).Top = Root.Height - pnlShadow(rbrMenu).Height
	End If
		 
	'------------------------
	DSmenu(rbrMenu).Initialize(Me, "DSMenu")
	pnlDSmenu(rbrMenu).AddView(DSmenu(rbrMenu).AsView, 1dip, 1dip, pnlDSmenu(rbrMenu).Width, pnlDSmenu(rbrMenu).Height)
	ColWidthDSmenu(0) = WidthMenu
	ColWidthDSmenu(1) = pnlDSmenu(rbrMenu).Width - 2 * WidthMenu
	ColWidthDSmenu(2) = WidthMenu
			
	DSmenu(rbrMenu).NewColor(0xFFD7D7D7)
	pnlDSmenu(rbrMenu).Elevation = 10dip
	
	j = 0
	For i = From1 To To1
		If MenuS(j).SubString2(1, 2) = 0 Then
			e = False
		Else
			e = True
		End If
		If MenuS(j).SubString2(3, 4) = "0" Then
			d = 0
		Else
			d = 2dip
		End If
		If MenuS(j).SubString2(0, 1) = "1" And MenuS(j).Length > 5  Then
			DSmenu(rbrMenu).Add(AddRowDSmenu(MenuS(j).SubString(5), MenuS(j).SubString2(1, 2), MenuS(j).SubString2(4, 5), MenuS(j).SubString2(2,3), RowHeightDSmenu), RowHeightDSmenu, i, d, e)
			PanelHe = PanelHe + RowHeightDSmenu + d
			NumberOfRowsDSmenu = NumberOfRowsDSmenu + 1
		End If
		j = j + 1
	Next
	pnlDSmenuInvisible.Visible = True
	pnlDSmenuInvisible.BringToFront
	pnlShadow(rbrMenu).Visible = True
	pnlDSmenu(rbrMenu).Visible = True
	pnlDSmenu(rbrMenu).BringToFront
End Sub
Sub AddRowDSmenu(Tx As String, Enabled As String, HaveNext As String, Checked As String, Height As Int) As Panel
	Dim P As Panel
	Dim i As Int
	P.Initialize("")
	P.Color = 0xFFF2F2F2
	P.Enabled=False
	Dim ColWidth As Int
	ColWidth=0
	For i = 0 To 2
		Dim l As Label
		l.Initialize("")
		l.Gravity = AlignmentDSmenu(I)
		l.TextSize =TextSize
		l.Typeface=Typeface.FONTAWESOME
		Select Case i
			Case 0
				If Checked = "1" Then l.Text=Chr(0xF00C) Else l.Text = ""
				If Enabled = 0 Then
					l.Enabled = False
					l.TextColor = 0xFF9F9F9F
				Else
					l.TextColor = Colors.Black
				End If
				l.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
			Case 1
				l.Text = Tx
				If Enabled = 0 Then
					l.Enabled = False
					l.TextColor = 0xFF9F9F9F
				Else
					l.TextColor = Colors.Black
				End If
				l.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
			Case 2
				If HaveNext = "1" Then l.Text = Chr(0xF105) Else l.Text = ""
				If Enabled = 0 Then
					l.Enabled = False
					l.TextColor = 0xFFFF9F9F9F
				Else
					l.TextColor = Colors.Black
				End If
				l.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
		End Select
		P.AddView(l , ColWidth, 0, ColWidthDSmenu(i), Height)
		l.Enabled = False
		ColWidth = ColWidth + ColWidthDSmenu(i)
	Next
	Return P
End Sub

Sub SetLabelTextSize(ex As Label, txt As String)
	Dim dt As Float
	Dim limit = 0.5 As Float
	Dim h As Int
	Dim stu As StringUtils
	ex.Text = txt
	ex.TextSize = 72
	dt = ex.TextSize
	h = stu.MeasureMultilineTextHeight(ex, txt)
	Do While dt > limit Or h > ex.Height
		dt = dt / 2
		h = stu.MeasureMultilineTextHeight(ex, txt)
		If h > ex.Height Then
			ex.TextSize = ex.TextSize - dt
		Else
			ex.TextSize = ex.TextSize + dt
		End If
	Loop
	ex.TextSize = ex.textsize * 0.8
End Sub

Sub SpecifyWidth(From1 As Int, To1 As Int, MenuS() As String)
	Dim i, j As Int
	Dim C As Canvas
	C.Initialize(lblInvisible)
	WidthMax = 0
	j = 0
	For i = From1 To To1
		If MenuS(j).SubString2(0, 1) = "1" Then
			Dim X As Int
			lblInvisible.Text = MenuS(j).SubString(4)
			X = C.MeasureStringWidth(lblInvisible.Text, lblInvisible.Typeface, TextSize)
			If X > WidthMax Then WidthMax = X
		End If
		j = j + 1
	Next
End Sub

Sub CloseActivities
	Dim jo As JavaObject
	jo.InitializeContext
	'jo.RunMethod("finishAffinity", Null) ' one way
	jo.RunMethod("finishAndRemoveTask", Null) 'another way
End Sub

Sub IsVisible(MenuS() As String, Index As Int) As Boolean
	If MenuS(Index).SubString2(0,1) = "1" Then
		Return True
	Else
		Return False
	End If
End Sub

Sub SetVisible(MenuS() As String, Index As Int, Visibled As Boolean)
	If Visibled Then
		MenuS(Index) = "1" & MenuS(Index).SubString(1)
	Else
		MenuS(Index) = "0" & MenuS(Index).SubString(1)
	End If
End Sub

Sub IsEnabled(MenuS() As String, Index As Int) As Boolean
	If MenuS(Index).SubString2(1,2) = "1" Then
		Return True
	Else
		Return False
	End If
End Sub

Sub SetEnabled(MenuS() As String, Index As Int, Enabled As Boolean)
	If Enabled Then
		MenuS(Index) = MenuS(Index).SubString2(0, 1) & "1" & MenuS(Index).SubString(2)
	Else
		MenuS(Index) = MenuS(Index).SubString2(0, 1) & "0" & MenuS(Index).SubString(2)
	End If
End Sub

Sub IsChecked(MenuS() As String, Index As Int) As Boolean
	If MenuS(Index).SubString2(2, 3) = "1" Then
		Return True
	Else
		Return False
	End If
End Sub

Sub SetChecked(MenuS() As String, Index As Int, Checked As Boolean)
	If Checked Then
		MenuS(Index) = MenuS(Index).SubString2(0, 2) & "1" & MenuS(Index).SubString(3)
	Else
		MenuS(Index) = MenuS(Index).SubString2(0, 2) & "0" & MenuS(Index).SubString(3)
	End If
End Sub

Sub IsHaveLine(MenuS() As String, Index As Int) As Boolean
	If MenuS(Index).SubString2(3, 4) = "1" Then
		Return True
	Else
		Return False
	End If
End Sub

Sub SetHaveLine(MenuS() As String, Index As Int, HaveLine As Boolean)
	If HaveLine Then
		MenuS(Index) = MenuS(Index).SubString2(0, 3) & "1" & MenuS(Index).SubString(4)
	Else
		MenuS(Index) = MenuS(Index).SubString2(0, 3) & "0" & MenuS(Index).SubString(4)
	End If
End Sub

Sub IsText(MenuS() As String, Index As Int, Tx As String) As Boolean
	If MenuS(Index).SubString(5) = Tx Then
		Return True
	Else
		Return False
	End If
End Sub

Sub SetText(MenuS() As String, Index As Int, Tx As String)
	MenuS(Index) = MenuS(Index).SubString2(0, 5) & Tx
End Sub

Sub DSmenu_ItemClick (Index As Int, Value As Int)
	Dim i, j As Int
	Dim pnl As Panel
	Dim cd1 As ColorDrawable
	cd1.Initialize2(0xff91c9f7, 20, 5dip, 0xFFf2f2f2)
	j = SpecifyGrid(Value)
	For i = 0 To DSmenu(j).GetSize - 1
		If i = Index Then
			pnl = DSmenu(j).GetPanel(i)
			pnl.Background = cd1
		Else
			pnl = DSmenu(j).GetPanel(i)
			pnl.Color = Colors.Transparent
		End If
	Next
	Select Value
		Case 10, 12, 13, 14
			Label6.Text = Menu1(Value - 10).SubString(5) & " - clicked"
			pnlDSmenuInvisible_Click
		Case 11
			ShowDSMenu(20, 22, Menu12, Null, 1, 1, 0)
		Case 20
			Label6.Text = Menu12(Value - 20).SubString(5) & " - clicked"
			pnlDSmenuInvisible_Click
		Case 21
			If IsChecked(Menu12, 1) Then
				SetChecked(Menu12, 1, False)
				Label6.Text = Menu12(Value - 20).SubString(5) & " - not chacked"
			Else
				SetChecked(Menu12, 1, True)
				Label6.Text = Menu12(Value- 20).SubString(5) & " - chacked"
			End If
			pnlDSmenuInvisible_Click
		Case 22
			ShowDSMenu(25, 27, Menu123, Null, 2, 2, 0)
		Case 25
			ShowDSMenu(30, 36, Menu1231, Null, 3, 0, 0)
		Case 26, 27
			Label6.Text = Menu123(Value - 25).SubString(5) & " - clicked"
			pnlDSmenuInvisible_Click
		Case 30, 31, 32, 33, 34, 35, 36
			Label6.Text = Menu1231(Value - 30).SubString(5) & " - clicked"
			pnlDSmenuInvisible_Click
		Case 100, 101, 102, 104
			Label6.Text = Menu2(Value - 100).SubString(5) & " - clicked"
			pnlDSmenuInvisible_Click
		Case 103
			ShowDSMenu(110, 112, Menu21, Null, 1, 3, 0)
		Case 105
			ShowDSMenu(115, 116, Menu22, Null, 1, 5, 0)
		Case 110, 111, 112
			Label6.Text = Menu21(Value - 110).SubString(5) & " - clicked"
			pnlDSmenuInvisible_Click
		Case 115, 116
			Label6.Text = Menu22(Value-115).SubString(5) & " - clicked"
			pnlDSmenuInvisible_Click
	End Select
End Sub

Sub pnlDSmenuInvisible_Click
	Dim i As Int
	If pnlDSmenuInvisible.Visible Then
		For i = 0 To 2
			If DSmenu(i).IsInitialized Then
				DSmenu(i).Clear
				pnlShadow(i).Visible = False
			End If
		Next
		pnlDSmenuInvisible.Visible = False
	End If
End Sub

'For test-------------------------------------------------------------------
Private Sub Panel1_Touch (Action As Int, X As Float, Y As Float)
	m1.Left = X
	m1.Top = Y
	m2.Left = m1.Left + m1.Width
	m2.Top = Y
	If m2.Left + m2.Width > Root.Width Then
		m1.Left = Root.Width - 2 * m1.Width
		m2.Left = Root.Width - m1.Width
	End If
End Sub

Private Sub m1_Click
	ShowDSMenu(10, 14, Menu1, m1, 0, 0, 0)
End Sub

Private Sub m2_Click
	ShowDSMenu(100, 105, Menu2, m2, 0, 0, 0)
End Sub

Sub Buttons_Click
	Private btn As Button
	btn = Sender
	Select Case btn.Tag
		Case 1
			If IsVisible(Menu1, 4) Then
				SetVisible(Menu1, 4, False)
				Label6.Text = "Menu14 is not visible"
			Else
				SetVisible(Menu1, 4, True)
				Label6.Text = "Menu14 is visible"
			End If
		Case 2
			If IsEnabled(Menu12, 0) Then
				SetEnabled(Menu12, 0,False)
				Label6.Text = "Menu120 is not enabled"
			Else
				SetEnabled(Menu12, 0, True)
				Label6.Text = "Menu120 is enabled"
			End If
		Case 3
			If IsChecked(Menu12, 1) Then
				SetChecked(Menu12, 1,False)
				Label6.Text = "Menu121 is Not chacked"
			Else
				SetChecked(Menu12, 1, True)
				Label6.Text = "Menu121 is chacked"
			End If
		Case 4
			If IsHaveLine(Menu2, 3) Then
				SetHaveLine(Menu2, 3,False)
				Label6.Text = "Menu23 is Not have line"
			Else
				SetHaveLine(Menu2, 3, True)
				Label6.Text = "Menu23 is have line"
			End If
		Case 5
			If IsText(Menu1, 4, "Menu 14") Then
				SetText(Menu1, 4, "Menu menu 14")
				Label6.Text = "'Menu 14' change to 'Menu menu 14'"
			Else
				SetText(Menu1, 4, "Menu 14")
				Label6.Text = "'Menu menu 14' change to 'Menu 14'"
			End If
	End Select
	'--------------------------------------------------------------------End for test
End Sub
